<?php
if (!defined('ABSPATH')) {
    exit;
}
function ccpw_load_assets($type, $post_id)
{

    if (!wp_script_is('jquery', 'done')) {
        wp_enqueue_script('jquery', 'true');
    }
    // global assets
    wp_register_script('ccpw_react-wdgets', CCPWP_URL . 'includes/react-widget/build/index.js', array('wp-element'), CCPWP_VERSION, true);
    wp_register_script('ccpw-lscache', CCPWP_URL . 'assets/js/lscache.min.js', array('jquery'), CCPWP_VERSION, true);   
    wp_enqueue_script('ccpw-numeral', CCPWP_URL . 'assets/js/numeral.min.js', array('jquery'), CCPWP_VERSION);
    wp_register_style('ctl-bootstrap', CCPWP_URL . 'assets/css/min/bootstrap.min.css', array(), CCPWP_VERSION, null);
    wp_enqueue_style('ccpwp-styles', CCPWP_URL . 'assets/css/min/ccpwp-styles.min.css', array(), CCPWP_VERSION, null, 'all');
    wp_enqueue_style('ccpwp-icons', CCPWP_URL . 'assets/css/ccpw-icons.css', array(), CCPWP_VERSION, null, 'all');
    wp_enqueue_style('dashicons');

    $is_live_changes = get_post_meta($post_id, 'live_changes', true);
    $binance_url = get_post_meta($post_id, 'binance_url', true);

    if ($type == 'binance-live-widget') {
        if ($is_live_changes == "on") {
            wp_enqueue_script('ccpw-jquery-number', CCPWP_URL . 'assets/js/jquery.number.min.js', array('jquery'), CCPWP_VERSION, true);

            wp_enqueue_script('ccpw_stream', CCPWP_URL . 'assets/js/stream.js', array('jquery'), CCPWP_VERSION, true);
            $binance_url = get_post_meta($post_id, 'binance_url', true);
            wp_localize_script('ccpw_stream', 'ccpw_data', array('bUrl' => $binance_url));
        }
        wp_enqueue_script('ccpw-binance-live-widget', CCPWP_URL . 'assets/js/ccpw-binance-live-widget.js', array('jquery'), CCPWP_VERSION, true);
        $binance_url = get_post_meta($post_id, 'binance_url', true);
        wp_localize_script('ccpw-binance-live-widget', 'ccpw_data', array('bUrl' => $binance_url));
        wp_enqueue_style('ccpwp-vue-widget-style', CCPWP_URL . 'assets/css/vue-widget-style.css', array(), CCPWP_VERSION, null, 'all');
    } else if ($type == 'price-block') {
        $binance_url = get_post_meta($post_id, 'binance_url', true);
        wp_enqueue_style('ccpw-price-block', CCPWP_URL . 'assets/css/ccpw-price-block.css', null, CCPWP_VERSION);
        wp_enqueue_script('ccpw_react-wdgets');
        wp_localize_script(
            'ccpw_react-wdgets',
            'ccpw_react_data',
            array(
                'restUrl' => get_rest_url(),
                'bUrl' => $binance_url,
                'home_url' => home_url(),
                'cmc_slug' => get_cmc_single_page_slug(),
                'translations' => ccpw_get_translations(),
                'cmc_enabled' => get_option('cmc-dynamic-links'),
            )
        );
        $disable_bootstrap = get_post_meta($post_id, 'disable_bootstrap', true);
        $design_block = get_post_meta($post_id, 'design_block', true);
        if ($disable_bootstrap != true) {
            wp_enqueue_style('ctl-bootstrap');
        }

        //  else if ($design_block == 'style-5') {
        //     wp_enqueue_style('ccpw_block_odometer_style', CCPWP_URL . 'assets/css/ccpw-odometer-theme-default.css', null, CCPWP_VERSION);

        // }
    } else if ($type == 'accordion-block') {
        $binance_url = get_post_meta($post_id, 'binance_url', true);
        wp_enqueue_style('ccpw-price-block', CCPWP_URL . 'assets/css/ccpw-price-block.css', null, CCPWP_VERSION);
        // wp_enqueue_style('ccpw-price-block', CCPWP_URL . 'assets/css/min/ccpw-price-block.min.css', null, CCPWP_VERSION);
        wp_enqueue_script('ccpw_react-wdgets');
        wp_localize_script(
            'ccpw_react-wdgets',
            'ccpw_react_data',
            array(
                'bUrl' => $binance_url,
                'restUrl' => get_rest_url(),
                'home_url' => home_url(),
                'cmc_slug' => get_cmc_single_page_slug(),
                'translations' => ccpw_get_translations(),
                'cmc_enabled' => get_option('cmc-dynamic-links'),
            )
        );

    } else if ($type == "ticker") {
       // wp_enqueue_style('ccpw-tooltip-css', CCPWP_URL . 'assets/css/min/tooltipster.bundle.min.css', null, CCPWP_VERSION);
        wp_enqueue_style('ccpw-ticker', CCPWP_URL . 'assets/css/ccpw-ticker.css', null, CCPWP_VERSION);
        wp_enqueue_script('ccpw_react-wdgets');
        wp_localize_script(
            'ccpw_react-wdgets',
            'ccpw_react_data',
            array(
                'restUrl' => get_rest_url(),
                'home_url' => home_url(),
                'bUrl' => $binance_url,
                'translations' => ccpw_get_translations(),
                'cmc_slug' => get_cmc_single_page_slug(),
                'cmc_enabled' => get_option('cmc-dynamic-links'),
            )
        );
    } else if ($type == "list-widget") {
        $disable_bootstrap = get_post_meta($post_id, 'disable_bootstrap', true);
        // list widget styles
        if ($disable_bootstrap != true) {
            wp_enqueue_style('ctl-bootstrap');
        }
        $binance_url = get_post_meta($post_id, 'binance_url', true);

        wp_enqueue_style('ccpw-list-widget', CCPWP_URL . 'assets/css/ccpw-list-widget.css', null, CCPWP_VERSION);
        wp_enqueue_script('ccpw_react-wdgets');
        wp_localize_script(
            'ccpw_react-wdgets',
            'ccpw_react_data',
            array(
                'restUrl' => get_rest_url(),
                'bUrl' => $binance_url,
                'home_url' => home_url(),
                'cmc_slug' => get_cmc_single_page_slug(),
                'translations' => ccpw_get_translations(),
                'cmc_enabled' => get_option('cmc-dynamic-links'),
            )
        );

    } else if ($type == "price-label") {
        wp_enqueue_style('ccpw-price-label', CCPWP_URL . 'assets/css/ccpw-price-label.css', null, CCPWP_VERSION);
        wp_enqueue_script('ccpw_react-wdgets');
        wp_localize_script(
            'ccpw_react-wdgets',
            'ccpw_react_data',
            array(
                'restUrl' => get_rest_url(),
                'url' => CCPWP_URL,
                'bUrl' => $binance_url,
                'home_url' => home_url(),
                'cmc_slug' => get_cmc_single_page_slug(),
                'translations' => ccpw_get_translations(),
                'cmc_enabled' => get_option('cmc-dynamic-links'),
            )
        );
    } else if ($type == "chart") {
        wp_enqueue_style('ccpw-charts-style', CCPWP_URL . 'assets/css/ccpw-charts.css', null, CCPWP_VERSION);
        // dynamic chart assets
        wp_enqueue_script('amcharts51', CCPWP_URL . 'assets/js/index.js', array(), CCPWP_VERSION, true);
        wp_enqueue_script('amcharts52', CCPWP_URL . 'assets/js/xy.js', array(), CCPWP_VERSION, true);
        wp_enqueue_script('amcharts23', CCPWP_URL . 'assets/js/stock.js', array(), CCPWP_VERSION, true);
        wp_enqueue_script('amcharts54', CCPWP_URL . 'assets/js/Animated5.js', array(), CCPWP_VERSION, true);
        wp_enqueue_script('ccpw-lscache');
        wp_enqueue_script('ccpw-jquery-number', CCPWP_URL . 'assets/js/jquery.number.min.js', array('jquery'), CCPWP_VERSION, true);
        wp_enqueue_script('ccpw-chart-js', CCPWP_URL . 'assets/js/create-charts.js', array('jquery'), CCPWP_VERSION, true);
        wp_localize_script(
            'ccpw-chart-js',
            'ccpw_data_object',
            array('ajax_url' => admin_url('admin-ajax.php'),
                'nonce' => wp_create_nonce('ccpw-chart-ajax-nonce'),
            )
        );

    } else if ($type == "price-card") {
        $disable_bootstrap = get_post_meta($post_id, 'disable_bootstrap', true);
        if ($disable_bootstrap != true) {
            wp_enqueue_style('ctl-bootstrap');
        }
        wp_enqueue_style('ccpw-price-card', CCPWP_URL . 'assets/css/ccpw-price-card.css', null, CCPWP_VERSION);
        wp_enqueue_script('ccpw_react-wdgets');
        wp_localize_script(
            'ccpw_react-wdgets',
            'ccpw_react_data',
            array(
                'restUrl' => get_rest_url(),
                'url' => CCPWP_URL,
                'bUrl' => $binance_url,
                'home_url' => home_url(),
                'cmc_slug' => get_cmc_single_page_slug(),
                'translations' => ccpw_get_translations(),
                'cmc_enabled' => get_option('cmc-dynamic-links'),
            )
        );

    } else if ($type == "slider-widget") {   
        wp_enqueue_script('ccpw_react-wdgets');
        wp_localize_script(
            'ccpw_react-wdgets',
            'ccpw_react_data',
            array(
                'restUrl' => get_rest_url(),
                'home_url' => home_url(),
                'bUrl' => $binance_url,
                'translations' => ccpw_get_translations(),
                'cmc_slug' => get_cmc_single_page_slug(),
                'cmc_enabled' => get_option('cmc-dynamic-links'),
            )
        );
        wp_enqueue_style('ccpw-slider-widget', CCPWP_URL . 'assets/css/ccpw-slider-widget.css', null, CCPWP_VERSION);
         wp_enqueue_style('ctl-bootstrap');
      
    } else if ($type == "rss-feed") {
        $rss_style = get_post_meta($post_id, 'rss_style', true);
        if ($rss_style == "ticker-rss") {
            $rss_ticker_speed = get_post_meta($post_id, 'rss_ticker_speed', true);
            $speed_rss_ticker = !empty($rss_ticker_speed) ? $rss_ticker_speed : 15;
            $id = "ccpw-" . $type . "-" . $post_id;
            wp_enqueue_style('ccpw-news-ticker', CCPWP_URL . 'assets/css/min/ccpw-news-ticker.min.css', null, CCPWP_VERSION);
            wp_enqueue_script('ccpw_bxslider_js', CCPWP_URL . 'assets/js/jquery.bxslider.min.js', array('jquery'), CCPWP_VERSION, true);
            wp_add_inline_script('ccpw_bxslider_js', 'jQuery(document).ready(function($){
		   $(".ccpw-news-ticker #' . $id . '").each(function(index){
                    $(this).bxSlider({
                        ticker:true,
                        minSlides:1,
                        maxSlides:12,
                        slideWidth:"auto",
                        tickerHover:true,
                        wrapperClass:"tickercontainer",
                        speed:' . $speed_rss_ticker . '*4000,
                    });
		   });

	   });');
        } else if ($rss_style == "list-rss") {
            wp_enqueue_style('ccpw-news-ticker', CCPWP_URL . 'assets/css/min/ccpw-news-ticker.min.css', null, CCPWP_VERSION);
        }

    } else if ($type == "multi-currency-tab") {
        wp_enqueue_script('ccpw_react-wdgets');
        wp_localize_script(
            'ccpw_react-wdgets',
            'ccpw_react_data',
            array(
                'restUrl' => get_rest_url(),
                'home_url' => home_url(),
                'bUrl' => $binance_url,
                'translations' => ccpw_get_translations(),
                'cmc_slug' => get_cmc_single_page_slug(),
                'cmc_enabled' => get_option('cmc-dynamic-links'),
            )
        );
        wp_enqueue_style('ccpw-multi-currency-tabs', CCPWP_URL . 'assets/css/ccpw-multi-currency-tabs.css', null, CCPWP_VERSION);

    } else if ($type == 'calculator') {
        wp_enqueue_script('ccpw_react-wdgets');
        wp_localize_script(
            'ccpw_react-wdgets',
            'ccpw_react_data',
            array(
                'restUrl' => get_rest_url(),
                'url' => CCPWP_URL,
                'bUrl' => $binance_url,
                'home_url' => home_url(),
                'cmc_slug' => get_cmc_single_page_slug(),
                'translations' => ccpw_get_translations(),
                'cmc_enabled' => get_option('cmc-dynamic-links'),
            )
        );

        wp_enqueue_style('ccpw-calculator-style', CCPWP_URL . 'assets/css/min/ccpw-calculator.min.css', null, CCPWP_VERSION);

    } else if ($type == 'table-widget') {
        if ($is_live_changes == "on") {
            wp_enqueue_script('ccpw-jquery-number', CCPWP_URL . 'assets/js/jquery.number.min.js', array('jquery'), CCPWP_VERSION, true);

            wp_enqueue_script('ccpw_stream', CCPWP_URL . 'assets/js/stream.js', array('jquery'), CCPWP_VERSION, true);
            $binance_url = get_post_meta($post_id, 'binance_url', true);
            wp_localize_script('ccpw_stream', 'ccpw_data', array('bUrl' => $binance_url));
        }

        wp_enqueue_script('ccpw-datatable', CCPWP_URL . 'assets/js/jquery.dataTables.min.js', null, CCPWP_VERSION);
        wp_enqueue_script('ccpw-headFixer', CCPWP_URL . 'assets/js/tableHeadFixer.js', null, CCPWP_VERSION);
        wp_enqueue_style('ccpw-custom-datatable-style', CCPWP_URL . 'assets/css/ccpw-custom-datatable.css', null, CCPWP_VERSION);
        wp_enqueue_script('ccpw-table-script', CCPWP_URL . 'assets/js/ccpw-table-widget.js', array('jquery'), CCPWP_VERSION);
        wp_enqueue_script('ccpw-table-sort', CCPWP_URL . 'assets/js/tablesort.min.js', array('jquery'), CCPWP_VERSION);
        wp_localize_script(
            'ccpw-table-script',
            'ccpw_js_objects',
            array('ajax_url' => admin_url('admin-ajax.php'),
                'wp_nonce' => wp_create_nonce('ccpwf-tbl-widget'),
            )
        );
    } else if ($type == "coingecko-widget") {
        wp_enqueue_style('coingecko-widget-style', CCPWP_URL . 'assets/css/coingecko-widget.css', null, CCPWP_VERSION);
        wp_enqueue_script('ccpw-coingecko-marketlist', 'https://widgets.coingecko.com/coingecko-coin-market-ticker-list-widget.js', null, null);
        wp_enqueue_script('ccpw-coingecko-heatmap', 'https://widgets.coingecko.com/coingecko-coin-heatmap-widget.js', null, null);
        wp_enqueue_script('ccpw-coingecko-comparsion-chart', 'https://widgets.coingecko.com/coingecko-coin-compare-chart-widget.js', null, null);

    }

}
// Apply RTl css
add_action('init', 'ccpw_rtl_check');

function ccpw_rtl_check()
{
    global $wp_locale;
    $check = $wp_locale->is_rtl();
    if ($check == true) {
        wp_enqueue_style('ccpw_rtl_css', CCPWP_URL . 'assets/css/ccpw-rtl.css', null, CCPWP_VERSION);
    }
}
