<?php
if (!defined('ABSPATH')) {
    exit();
}
if (!class_exists('CCPWP_cronjob')) {
    class CCPWP_cronjob
    {



        public function __construct()
        {
            add_filter('cron_schedules', array($this, 'ccpwp_cron_schedules'));
            add_action('ccpwp_coins_autosave', array($this, 'ccpwp_cron_coins_autoupdater'));
			add_action('ccpw_coins_autosave_over250', array($this, 'do_this_3_day_after'));			
        }


        /*
|--------------------------------------------------------------------------
| Cron status schedule(s)
|-------------------------------------------------------------------------- 
*/
	function ccpwp_cron_schedules($schedules)
	{
		// 5 minute schedule for grabing all coins 
		if (!isset($schedules["5min"])) {
			$schedules["5min"] = array(
				'interval' => 5 * 60,
				'display' => __('Once every 5 minutes')
			);
		}
		if (!isset($schedules["3days"])) {
			$schedules["3days"] = array(
				'interval' => 259200,
				'display' => __('Once every 3 days'),
			);
		}
		return $schedules;
	}

    /*
|--------------------------------------------------------------------------
| initialize cron : MUST USE ON PLUGIN ACTIVATION
|--------------------------------------------------------------------------
*/
	public function ccpwp_cron_job_init(){
		$get_license = get_option('ccpw_license_registration');
        $purchased_code = isset($get_license["ccpw-purchase-code"]) ? $get_license["ccpw-purchase-code"] : '';    
        $api_option = get_option("openexchange-api-settings");
        $coingecko_api_key = (isset($api_option['coingecko_api'])) ? $api_option['coingecko_api'] : "";
		
		// Do not proceed further if
        
		if(ccpwp_check_user()){
			if ( !class_exists('CoinMarketCap')) {
			if (!wp_next_scheduled('ccpwp_coins_autosave')) {
				wp_schedule_event(time(), '5min', 'ccpwp_coins_autosave');
			}
			if (!wp_next_scheduled('ccpw_coins_autosave_over250')) {
				wp_schedule_event(strtotime("+5 seconds"), '3days', 'ccpw_coins_autosave_over250');
			}
		}
		}
		
	}

/*
|--------------------------------------------------------------------------
| Must be run through cron
|--------------------------------------------------------------------------
*/
	public function ccpwp_cron_coins_autoupdater(){
		if ( !class_exists('CoinMarketCap')) {
			//update coins data;
			//$api_obj=new CCPWP_api_data();
			CCPWP_api_data::ccpwp_get_api_data();
		}	
	}
	/*
|--------------------------------------------------------------------------
| grabing coin weekly price data(historical)for small charts
|--------------------------------------------------------------------------
 */
public function do_this_3_day_after()
{
	if ( !class_exists('CoinMarketCap')) {
	for ($page = 2; $page <= 5; $page++) {
		CCPWP_api_data::ccpwp_get_api_data($page);  
		          
	}
	sleep(60);
	for ($page = 6; $page <= 10; $page++) {
		CCPWP_api_data::ccpwp_get_api_data($page);  
		          
	}
}
}



    }

    $cron_init=new CCPWP_cronjob();
}
